# Changelog

## [2.1.1] - 2023-03-27

### Fixed

- Fixed degenerate case for `ImageTargetPreview`.
- Fixed an issue where the wrong camera would be used in `iOS 16.4`.


## [2.1.0] - 2023-02-08

### Changed

- Module is now built as `ESNext` (was `CommonJs`).

## [2.1.0-beta.1] - 2023-02-06

### Added
- Spanish, Portuguese and German translations for permissions screen

### Changed

- Improvements to curved tracking

## [2.0.0] - 2022-08-23

### Added

- Greatly improved instant tracking.
- Introduced `SequenceSource` and pipeline functions to record and playback sequences of camera+motion data.
- Added support for curved tracking.
- Added support for fetching image element containing target image's embedded preview image.
- Improved GL state management.

### Changed

- Migrated to Webpack 5 workers.

## [0.3.18] - 2021-02-08

- Additional WebGL state is preserved during `process_gl` calls

## [0.3.17] - 2021-02-08

### Fixed

- External WebGL state is preserved during `process_gl` calls

## [0.3.16] - 2022-01-25

### Fixed

- Issues on Ipad Pro

## [0.3.15] - 2021-10-28

### Changed

- Pinned dependencies to exact versions

## [0.3.14] - 2021-09-22

### Added

- loaded() function which returns true once the library is fully loaded and available for use
- loadedPromise() function which returns a promise that resolves once the library is fully loaded and available for use

### Changed

- Bucket 172.* IP address range into one license check.

### Fixed

- Issues with other browsers on iOS, including social browsers

## [0.3.13] - 2021-08-20

### Changed

- Optimized [0.3.11] face tracking fix.

## [0.3.12] - 2021-08-20

### Fixed

- Issue in multiple face tracking, where if the first anchor becomes invisible, the others stop tracking. <https://github.com/zappar-xr/zappar-threejs/issues/85>

## [0.3.11] - 2021-06-10

### Added

- Typedoc comments.

### Fixed

- Some typos in `README.md`.

## [0.3.10] - 2021-04-23

### Changed

- Exposed near and far clipping planes in `projectionMatrixFromCameraModel` parameters.

### Added

- `zFar` and `zNear` documentation to `README.MD`.

## [0.3.9] - 2021-04-12

- Cleaned up tests.

### Added

- ESLint.

### Fixed

- All internal methods now have valid return types.
- Incorrect dates in `CHANGELOG.md`.
- NPM vulnerabilities.

### Changed

- Made `FaceMesh` `load` parameters optional, defaulting to loading default face.

## [0.3.8] - 2021-02-18

### Added

- pipeline.glContextLost() to indicate that the GL context is lost
- logLevel() and setLogLevel(...) to customize volume of log output

### Changed

- License checks now only happen on first pipeline construction

### Fixed

- pipeline.glContextSet(...) correctly handles multiple invocations

## [0.3.7] - 2021-02-03

### Added

- Table of contents to `README.md`

### Fixed

- README now states that the GL active texture state is changed during some GL-specific calls
- Fixed issues on Chrome for iOS

### Changed

- Dependencies update
- Updated README to reference support for iOS WKWebView from iOS 14.3 and later

## [0.3.5] - 2020-11-26

### Added

- This changelog :-)
- Console log the version when the library is initialized

### Fixed

- Prevent flickering when there are no new camera frames
- Fixed building with recent versions of `worker-loader`

### Changed

- Dependencies update
- Remove unnecessary console logging
- Updated the README to recommend using `visibilitychange` to pause/start the camera

## [0.3.4] - 2020-11-18

### Added

- Pipeline `destroy()` function

### Fixed

- Ensure internal GL usage correctly sets the expected active texture
- Fixed typo in README.md

### Changed

- Added syntax highlighting to README.md

## [0.3.3] - 2020-11-04

### Added

- Browser compatibility API and UI
- README section detailing browser support

### Changed

- Modifications to browser compatibility API

## [0.3.2] - 2020-11-04

### Added

- Browser compatibility API and UI

### Fixed

- Support for Firefox

## [0.3.1] - 2020-11-03

### Fixed

- Various enums are now available as objects
- Removed unnecessary TypeScript files included in deployment

## [0.3.0] - 2020-11-02

### Added

- Support for face landmarks
- Greatly improved face tracking model

### Fixed

- Fixes to iPad support

### Changed

- Dependencies update

## [0.2.12] - 2020-10-19

### Fixed

- Fixes to iPad support

### Changed

- Dependencies update

## [0.2.12] - 2020-10-19

### Fixed

- Fixes to iPad support

### Changed

- Dependencies update

## [0.2.11] - 2020-09-15

### Fixed

- Fix issues with iOS 14

### Changed

- Dependencies update

## [0.2.9] - 2020-07-08

### Fixed

- Tweaks to computer vision algorithms

## [0.2.6] - 2020-06-09

### Added

- Support for full head meshes

## [0.2.5] - 2020-06-02

### Added

- Support for NGROK
- Added README.md clarifications around licensing

## [0.2.4] - 2020-05-26

Initial release
